import { isVue3 as y, h as u, computed as W, unref as Re, defineComponent as M, ref as S, watch as Q, onMounted as Ve, onBeforeUnmount as ze, Vue2 as Be } from "vue-demi";
import { createListenerPropsForwarder as q, pick as w, withDefaultProps as H, partition as X, isHandlerKey as Le, normalizeListenerKeys as U, isObject as Ke, useListeners as ke, isString as $e, mergeProps as N, isFunction as K } from "@visoning/vue-utility";
import { FloatingCreatorProps as be, useManualEffect as Me, FloatingCreator as Y } from "@visoning/vue-floating-core";
import { InteractorProps as he, createInteractorForwardContext as qe, useInteractorContext as He, Interactor as Z } from "@visoning/vue-floating-interactions";
import { createInteractorForwardContext as tr, useInteractorContext as rr } from "@visoning/vue-floating-interactions";
import { offset as Ge, shift as Je, flip as Qe, autoPlacement as Xe, arrow as Ye } from "@floating-ui/core";
var Ze = Object.defineProperty, et = Object.defineProperties, tt = Object.getOwnPropertyDescriptors, ee = Object.getOwnPropertySymbols, rt = Object.prototype.hasOwnProperty, ot = Object.prototype.propertyIsEnumerable, te = (e, t, r) => t in e ? Ze(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, z = (e, t) => {
  for (var r in t || (t = {}))
    rt.call(t, r) && te(e, r, t[r]);
  if (ee)
    for (var r of ee(t))
      ot.call(t, r) && te(e, r, t[r]);
  return e;
}, nt = (e, t) => et(e, tt(t));
const je = q(be, ["onFloatingDataUpdate"]), at = w(be, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate"
]), st = w(he, [
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside"
]), pt = nt(z(z(z({}, at), je.props), st), {
  open: Boolean,
  defaultOpen: Boolean,
  disabled: Boolean,
  virtualElement: Object,
  appendTo: {},
  autoUpdateOnClosed: Boolean,
  offset: [Number, Object, Function],
  shift: [Boolean, Object],
  flip: [Boolean, Object],
  autoPlacement: [Boolean, Object],
  gpuAcceleration: Boolean,
  destoryedOnClosed: Boolean,
  floatingProps: Object,
  floatingWrapper: Function,
  popupProps: Object,
  popupWrapper: Function,
  zIndex: Number,
  "onUpdate:open": Function,
  onOpen: Function,
  onClose: Function
}), lt = {
  open: void 0,
  defaultOpen: !1,
  shift: !0,
  appendTo: "body"
}, G = H(pt, lt);
var it = Object.defineProperty, ct = Object.defineProperties, ut = Object.getOwnPropertyDescriptors, R = Object.getOwnPropertySymbols, xe = Object.prototype.hasOwnProperty, De = Object.prototype.propertyIsEnumerable, re = (e, t, r) => t in e ? it(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, B = (e, t) => {
  for (var r in t || (t = {}))
    xe.call(t, r) && re(e, r, t[r]);
  if (R)
    for (var r of R(t))
      De.call(t, r) && re(e, r, t[r]);
  return e;
}, dt = (e, t) => ct(e, ut(t)), ft = (e, t) => {
  var r = {};
  for (var a in e)
    xe.call(e, a) && t.indexOf(a) < 0 && (r[a] = e[a]);
  if (e != null && R)
    for (var a of R(e))
      t.indexOf(a) < 0 && De.call(e, a) && (r[a] = e[a]);
  return r;
};
function V(e, t, r) {
  if (r = Array.isArray(r) ? r : [r], y)
    return u(e, t.data, t.scopedSlots ? dt(B({}, t.scopedSlots), {
      default: (...l) => {
        var O, m;
        return r.concat((m = (O = t.scopedSlots) == null ? void 0 : O.default) == null ? void 0 : m.call(O, ...l));
      }
    }) : r);
  const a = t.data, {
    key: _,
    ref: $,
    class: b,
    style: p,
    scopedSlots: P
  } = a, i = ft(a, [
    "key",
    "ref",
    "class",
    "style",
    "scopedSlots"
  ]), [j, x] = X(Object.keys(i), (l) => Le(l)), { propKeys: o } = t, [s, d] = X(x, (l) => !(o != null && o.includes(l)));
  return u(e, {
    key: _,
    ref: $,
    class: b,
    style: p,
    props: w(i, d),
    attrs: w(i, s),
    scopedSlots: B(B({}, P), t.scopedSlots),
    on: U(w(i, j))
  }, r);
}
let Ee, Ce, Se, k;
try {
  const e = require("vue");
  Ee = e.Transition, Ce = e.Teleport, Se = e.vShow, k = e.withDirectives;
} catch {
}
function vt(e) {
  return W(() => {
    const t = Re(e), r = [];
    return t.offset && r.push(Ge(t.offset)), t.shift && r.push(Je(L(t.shift))), t.flip && r.push(Qe(L(t.flip))), t.autoPlacement && r.push(Xe(L(t.autoPlacement))), r.concat(t.middleware || []);
  });
}
function L(e, t = {}) {
  return Ke(e) ? e : t;
}
var Pt = Object.defineProperty, _t = Object.defineProperties, Ot = Object.getOwnPropertyDescriptors, oe = Object.getOwnPropertySymbols, mt = Object.prototype.hasOwnProperty, gt = Object.prototype.propertyIsEnumerable, ne = (e, t, r) => t in e ? Pt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, h = (e, t) => {
  for (var r in t || (t = {}))
    mt.call(t, r) && ne(e, r, t[r]);
  if (oe)
    for (var r of oe(t))
      gt.call(t, r) && ne(e, r, t[r]);
  return e;
}, ae = (e, t) => _t(e, Ot(t));
const se = {
  floating: "visoning-floating",
  popup: "visoning-popup"
}, pe = M({
  name: "VisoningPopup",
  inheritAttrs: !1,
  props: G,
  setup(e, { slots: t, attrs: r, expose: a }) {
    const _ = S(!!e.defaultOpen), $ = W(() => e.open === void 0 ? _.value : e.open), b = ke(), p = (n, v) => {
      _.value = n, n !== e.open && (b.emit("update:open", n, v), b.emit(n ? "open" : "close", v));
    }, P = qe(), i = He();
    Q(P, (n) => i == null ? void 0 : i.setInteractor(n));
    const j = W(() => e.virtualElement || P.value), x = S(), o = vt(e), s = W(() => {
      const { appendTo: n } = e;
      return n === !1 ? P.value : $e(n) ? document.querySelector(n) : n;
    }), d = S();
    if (!y) {
      const n = () => {
        const { value: g } = s;
        if (!g)
          return;
        const f = new Be({
          render() {
            return d.value;
          }
        });
        return f.$mount(), g.appendChild(f.$el), () => {
          var E;
          f.$destroy(), (E = f.$el) == null || E.remove();
        };
      }, { clear: v, reset: c } = Me(n);
      Q(s, () => c()), Ve(c), ze(v);
    }
    const l = S();
    a({
      getElements: () => ({
        floating: x.value,
        reference: P.value
      }),
      updatePosition: () => {
        var n;
        return (n = l.value) == null ? void 0 : n.updatePosition();
      },
      getFloatingData: () => {
        var n;
        return (n = l.value) == null ? void 0 : n.getFloatingData();
      }
    });
    const m = (n) => e.gpuAcceleration ? {
      position: n.strategy,
      top: 0,
      left: 0,
      transform: `translate3d(${n.x}px, ${n.y}px, 0px)`,
      zIndex: e.zIndex
    } : {
      position: n.strategy,
      top: `${n.y}px`,
      left: `${n.x}px`,
      zIndex: e.zIndex
    }, D = (n, v) => {
      let c = V("div", {
        data: N(e.floatingProps, {
          ref: x,
          class: se.floating,
          style: m(n)
        })
      }, [v]);
      if (e.floatingWrapper && (c = e.floatingWrapper(c)), y)
        return u(Ce, {
          to: s.value
        }, {
          default: () => [c]
        });
      d.value = c;
    }, F = (n) => {
      var v;
      const { value: c } = $, { destoryedOnClosed: g } = e;
      if (!c && g)
        return;
      const f = V("div", {
        data: N(e.popupProps, {
          class: se.popup
        })
      }, (v = t.default) == null ? void 0 : v.call(t, n));
      if (y)
        k && k(f, [[Se, c, "show"]]);
      else {
        const E = {
          name: "show",
          value: c
        };
        (f.data.directives || (f.data.directives = [])).push(E);
      }
      return e.popupWrapper ? e.popupWrapper(f) : f;
    }, A = (n) => {
      var v;
      const c = (v = t.reference) == null ? void 0 : v.call(t), g = ae(h({}, w(e, Object.keys(he))), {
        active: $.value
      }), f = {
        "onUpdate:active": p
      };
      return y ? u(Z, h(h(h({}, r), g), f), [c, n]) : u(Z, {
        attrs: r,
        props: g,
        on: U(f)
      }, c);
    };
    return () => {
      const n = e.disabled || !$.value && !e.autoUpdateOnClosed, v = {
        ref: l
      }, c = {
        reference: j.value,
        floating: x.value,
        disabled: n,
        placement: e.placement,
        strategy: e.strategy,
        autoUpdate: e.autoUpdate,
        middleware: o.value
      }, g = je.forwards(), f = {
        default: (E) => {
          const We = F(E), Ue = D(E, We);
          return A(Ue);
        }
      };
      return y ? u(Y, h(h(h({}, c), g), v), f) : u(Y, ae(h({}, v), {
        props: c,
        on: U(g),
        scopedSlots: f
      }));
    };
  }
});
var wt = Object.defineProperty, yt = Object.defineProperties, $t = Object.getOwnPropertyDescriptors, le = Object.getOwnPropertySymbols, bt = Object.prototype.hasOwnProperty, ht = Object.prototype.propertyIsEnumerable, ie = (e, t, r) => t in e ? wt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, ce = (e, t) => {
  for (var r in t || (t = {}))
    bt.call(t, r) && ie(e, r, t[r]);
  if (le)
    for (var r of le(t))
      ht.call(t, r) && ie(e, r, t[r]);
  return e;
}, jt = (e, t) => yt(e, $t(t));
const Fe = q(G, ["onFloatingDataUpdate", "onUpdate:open", "onOpen", "onClose"]), Ie = w(G, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "floatingProps",
  "floatingWrapper",
  "zIndex"
]), xt = jt(ce(ce({}, Ie), Fe.props), {
  title: [String, Function],
  content: [String, Function],
  theme: String,
  size: String,
  transitionProps: [String, Object],
  showArrow: Boolean,
  arrow: Function,
  arrowProps: Object,
  popoverProps: Object,
  contentProps: Object,
  popoverWrapper: Function
}), Te = "visoning-popover", Dt = {
  theme: "line",
  size: "meduim",
  transitionProps: Te,
  showArrow: !0
}, J = H(xt, Dt);
var Et = Object.defineProperty, Ct = Object.defineProperties, St = Object.getOwnPropertyDescriptors, ue = Object.getOwnPropertySymbols, Ft = Object.prototype.hasOwnProperty, It = Object.prototype.propertyIsEnumerable, de = (e, t, r) => t in e ? Et(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, C = (e, t) => {
  for (var r in t || (t = {}))
    Ft.call(t, r) && de(e, r, t[r]);
  if (ue)
    for (var r of ue(t))
      It.call(t, r) && de(e, r, t[r]);
  return e;
}, fe = (e, t) => Ct(e, St(t));
const I = {
  popover: "visoning-popover",
  content: "visoning-popover-content",
  title: "visoning-popover-title",
  arrow: "visoning-popover-arrow",
  dark: "theme-dark"
}, ve = M({
  name: "VisoningPopover",
  inheritAttrs: !1,
  props: J,
  setup(e, { attrs: t, expose: r, slots: a }) {
    const _ = S(), $ = ({
      placement: o,
      middlewareData: s
    }) => {
      var d, l, O, m;
      const D = (l = (d = s.arrow) == null ? void 0 : d.y) != null ? l : 0, F = (m = (O = s.arrow) == null ? void 0 : O.x) != null ? m : 0, A = {
        "--vp-arrow-top": `${D}px`,
        "--vp-arrow-left": `${F}px`
      };
      return o.includes("top") || o.includes("bottom") ? A.left = `${F}px` : A.top = `${D}px`, A;
    }, b = (o) => {
      const s = e.arrow || a.arrow;
      return s ? s(o) : u("div", {
        ref: _,
        class: I.arrow,
        style: $(o)
      });
    }, p = W(() => {
      const o = e.middleware || [];
      return e.showArrow && _.value && o.push(Ye({
        element: _.value
      })), o;
    }), P = (o) => {
      const { transitionProps: s } = e;
      if (s) {
        const d = $e(s) ? { name: s } : C({
          name: Te
        }, s);
        if (y) {
          const l = o;
          o = u(Ee, d, {
            default: () => l
          });
        } else
          o = u("transition", {
            props: d
          }, [o]);
      }
      return e.popoverWrapper ? e.popoverWrapper(o) : o;
    }, i = S();
    r({
      updatePosition: () => {
        var o;
        return (o = i.value) == null ? void 0 : o.updatePosition();
      },
      getFloatingData: () => {
        var o;
        return (o = i.value) == null ? void 0 : o.getFloatingData();
      },
      getElements: () => {
        var o;
        return ((o = i.value) == null ? void 0 : o.getElements()) || {};
      }
    });
    const x = (o) => {
      var s, d, l;
      const O = (s = e.title) != null ? s : a.title, m = (l = (d = e.content) != null ? d : a.content) != null ? l : a.default, D = K(O) ? O() : O, F = K(m) ? m() : m;
      return V("div", {
        data: N(e.popoverProps, {
          class: [
            I.popover,
            `size-${e.size}`,
            e.theme === "dark" && I.dark
          ],
          "data-placement": o.placement
        })
      }, [
        V("div", {
          data: N(e.contentProps, {
            class: I.content
          })
        }, [
          D && u("div", {
            class: I.title
          }, [D]),
          F
        ]),
        e.showArrow && b(o)
      ]);
    };
    return () => {
      const o = {
        ref: i
      }, s = fe(C({}, w(e, Object.keys(Ie))), {
        middleware: p.value,
        popupWrapper: P,
        popupProps: N(e.popoverProps, {
          class: I.popover
        })
      }), d = Fe.forwards(), l = {
        reference: a.reference,
        default: x
      };
      return y ? u(pe, C(C(C(C({}, t), s), d), o), l) : u(pe, fe(C({}, o), {
        props: s,
        on: U(d),
        attrs: t,
        scopedSlots: l
      }));
    };
  }
});
var Tt = Object.defineProperty, Nt = Object.defineProperties, At = Object.getOwnPropertyDescriptors, Pe = Object.getOwnPropertySymbols, Wt = Object.prototype.hasOwnProperty, Ut = Object.prototype.propertyIsEnumerable, _e = (e, t, r) => t in e ? Tt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, Oe = (e, t) => {
  for (var r in t || (t = {}))
    Wt.call(t, r) && _e(e, r, t[r]);
  if (Pe)
    for (var r of Pe(t))
      Ut.call(t, r) && _e(e, r, t[r]);
  return e;
}, Rt = (e, t) => Nt(e, At(t));
const Ne = q(J, ["onFloatingDataUpdate", "onUpdate:open", "onOpen", "onClose"]), Ae = w(J, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "floatingProps",
  "floatingWrapper",
  "zIndex",
  "content",
  "contentProps"
]), Vt = Rt(Oe(Oe({}, Ae), Ne.props), {
  textAlign: String,
  tooltipProps: Object,
  tooltipWrapper: Function
}), zt = {
  interactions: "hover",
  theme: "drak",
  textAlign: "start"
}, Bt = H(Vt, zt);
var Lt = Object.defineProperty, Kt = Object.defineProperties, kt = Object.getOwnPropertyDescriptors, me = Object.getOwnPropertySymbols, Mt = Object.prototype.hasOwnProperty, qt = Object.prototype.propertyIsEnumerable, ge = (e, t, r) => t in e ? Lt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, T = (e, t) => {
  for (var r in t || (t = {}))
    Mt.call(t, r) && ge(e, r, t[r]);
  if (me)
    for (var r of me(t))
      qt.call(t, r) && ge(e, r, t[r]);
  return e;
}, we = (e, t) => Kt(e, kt(t));
const ye = {
  tooltip: "visoning-tooltip",
  content: "visoning-tooltip-content"
}, Yt = M({
  name: "Tooltip",
  inheritAttrs: !1,
  props: Bt,
  setup(e, { attrs: t, slots: r, expose: a }) {
    const _ = S();
    a({
      updatePosition: () => {
        var p;
        return (p = _.value) == null ? void 0 : p.updatePosition();
      },
      getFloatingData: () => {
        var p;
        return (p = _.value) == null ? void 0 : p.getFloatingData();
      },
      getElements: () => {
        var p;
        return ((p = _.value) == null ? void 0 : p.getElements()) || {};
      }
    });
    const b = () => {
      var p, P;
      const i = (P = (p = e.content) != null ? p : r.content) != null ? P : r.default;
      return u("div", {
        style: {
          textAlign: e.textAlign
        }
      }, [
        u("span", {
          class: ye.content
        }, [K(i) ? i() : i])
      ]);
    };
    return () => {
      const p = {
        ref: _
      }, P = we(T({}, w(e, Object.keys(Ae))), {
        popoverProps: N(e.tooltipProps, {
          class: ye.tooltip
        }),
        popoverWrapper: e.tooltipWrapper
      }), i = Ne.forwards(), j = {
        reference: r.reference,
        arrow: r.arrow,
        content: b
      };
      return y ? u(ve, T(T(T(T({}, t), P), i), p), j) : u(ve, we(T({}, p), {
        props: P,
        on: U(i),
        attrs: t,
        scopedSlots: j
      }));
    };
  }
});
export {
  ve as Popover,
  I as PopoverClassNames,
  Dt as PopoverDefaultProps,
  J as PopoverProps,
  xt as PopoverPropsType,
  Te as PopoverTransitionName,
  pe as Popup,
  lt as PopupDefaultProps,
  G as PopupProps,
  pt as PopupPropsType,
  Yt as Tooltip,
  ye as TooltipClassNames,
  zt as TooltipDefaultProps,
  Bt as TooltipProps,
  Vt as TooltipPropsType,
  tr as createInteractorForwardContext,
  rr as useInteractorContext
};
